=== debian/changelog ===
primesieve (11.0+ds-2) unstable; urgency=medium

  * Team upload
  * Raising Standards version to 4.6.2 (no change)

 -- Pierre Gruet <pgt@debian.org>  Wed, 21 Dec 2022 18:10:23 +0100

primesieve (11.0+ds-1) unstable; urgency=medium

  * New upstream major release, new (C++) ABI (minor changes).
  * Debianization:
    - various minor janitorial changes.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 10 Dec 2022 18:32:19 +0000

primesieve (8.0+ds-3) unstable; urgency=medium

  * Debianization:
    - d/watch, update;
    - d/s/lintian-overrides, update.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 27 Nov 2022 15:20:54 +0000
