=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

## inspired from mpfr material
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS    += -O0
	CXXCFLAGS += -O0
else ifeq ($(DEB_HOST_ARCH),alpha)
	CFLAGS   += -mieee
	CXXFLAGS += -mieee
else ifeq ($(DEB_HOST_ARCH),sha4)
	CFLAGS   += -mieee
	CXXFLAGS += -mieee
else
	CFLAGS   := $(subst -O2,-O3,$(CFLAGS))
	CXXFLAGS := $(subst -O2,-O3,$(CXXFLAGS))
endif

BUILDDIR=_build

default:
	@uscan --no-conf --dehs --report || true

%:
	dh $@ --builddirectory=$(BUILDDIR)

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_TESTS=ON \
		-DBUILD_EXAMPLES=ON \
		-DBUILD_DOC=ON \
		-DBUILD_MANPAGE=ON

override_dh_auto_build-indep: README.implementation.md
	$(MAKE) -f debian/adhoc/Makefile doc

override_dh_auto_test-indep:
	true

override_dh_prep-arch: README.implementation.md

override_dh_auto_install-indep:
	DESTDIR=$(CURDIR)/debian/tmp $(CMAKE) \
			-DCMAKE_INSTALL_COMPONENT=libprimesieve-headers \
		-P $(BUILDDIR)/cmake_install.cmake

override_dh_installdocs:
	dh_installdocs -pprimesieve-bin    --link-doc=libprimesieve11
	dh_installdocs -plibprimesieve-dev --doc-main-package=libprimesieve-dev-common
	dh_installdocs --remaining-packages

override_dh_installexamples-indep:
	dh_installexamples -XCMakeLists.txt -XREADME.md

override_dh_compress-indep:
	dh_compress -X.pdf -Xexamples

README.implementation.md:
	cp -p src/README.md README.implementation.md

CMAKE ?= cmake
