=== debian/changelog ===
primesieve (11.1+ds-1) unstable; urgency=medium

  * New upstream minor release.
  * Debianization:
    - d/copyright:
      - copyright year-tuples, update;
    - d/control:
      - Standards-Version, bump to 4.6.2 (no change);
    - d/t/control:
      - dev-autogtests  allow stderr outputs (Closes: #1027814).

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 16 Jul 2023 13:00:17 +0000
