## primesieve 12.0%2Bds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
-cmake_minimum_required(VERSION 3.4...3.22)
+cmake_minimum_required(VERSION 3.4...3.27)
 project(primesieve CXX)
-set(PRIMESIEVE_VERSION "11.1")
-set(PRIMESIEVE_SOVERSION "11.1.0")
+set(PRIMESIEVE_VERSION "12.0")
+set(PRIMESIEVE_SOVERSION "12.0.0")
 
 # Build options ######################################################
 
@@ -48,9 +48,10 @@
 
 # primesieve binary source files #####################################
 
-set(BIN_SRC src/app/cmdoptions.cpp
+set(BIN_SRC src/app/CmdOptions.cpp
             src/app/help.cpp
             src/app/main.cpp
+            src/app/stressTest.cpp
             src/app/test.cpp)
 
 # primesieve library source files ####################################
@@ -74,6 +75,7 @@
             src/popcount.cpp
             src/PreSieve.cpp
             src/PrimeSieve.cpp
+            src/RiemannR.cpp
             src/SievingPrimes.cpp)
 
 # Required includes ##################################################
@@ -330,7 +332,3 @@
 # Add subdirectories #################################################
 
 if(BUILD_DOC)
-    add_subdirectory(doc)
-endif()
-
-if(BUILD_EXAMPLES)
