=== debian/changelog ===
primesieve (12.0+ds-2build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 06:49:18 +0000

primesieve (12.0+ds-2) unstable; urgency=medium

  * Debianization:
    - d/t/control:
      - Depends list, when applicable, rename pkg-config pkgconf.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 02 Mar 2024 19:30:01 +0000

primesieve (12.0+ds-1) unstable; urgency=medium

  * New upstream major version.
  * Debianization:
    - SONAME, bump to 12;
    - d/rules:
      - override_dh_installdocs target, SONAME machinery, harden;
    - d/t/make-check-dev, refresh;
    - d/control:
      - dev Suggests list, rename pkg-config pkgconf.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 24 Feb 2024 10:00:50 +0000

primesieve (11.2+ds-2) unstable; urgency=medium

  * Fail-to-Auto-Test fix release, it appeared that some headers
    were reorganized.
  * Debianization:
    - d/t/make-check-dev, refresh.

 -- Jerome Benoit <calculus@rezozer.net>  Fri, 26 Jan 2024 17:33:47 +0000

primesieve (11.2+ds-1) unstable; urgency=medium

  * New upstream minor release.
  * Debianization:
    - d/copyright:
      - copyright year-tuples, update.

 -- Jerome Benoit <calculus@rezozer.net>  Thu, 25 Jan 2024 16:28:26 +0000
