=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: primesieve
-Maintainer: Debian Math Team <team+math@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders: Jerome Benoit <calculus@rezozer.net>
 Section: math
 Priority: optional
@@ -29,7 +30,7 @@
  .
  This dummy package provides the standard installation.
 
-Package: libprimesieve11
+Package: libprimesieve12
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -52,9 +53,9 @@
 Breaks: libprimesieve7-dev
 Section: libdevel
 Depends:
- libprimesieve11 (= ${binary:Version}), libprimesieve-dev-common (= ${source:Version}),
+ libprimesieve12 (= ${binary:Version}), libprimesieve-dev-common (= ${source:Version}),
  ${misc:Depends}
-Suggests: primesieve-doc (= ${source:Version}), pkg-config
+Suggests: primesieve-doc (= ${source:Version}), pkgconf
 Description: fast prime number generator C/C++ library -- libdev
  primesieve is a free software program and C/C++ library that generates
  primes using a highly optimized sieve of Eratosthenes implementation.
