## primesieve 12.3+ds

=== debian/changelog ===
primesieve (12.3+ds-1) unstable; urgency=medium

  * New upstream minor version.
  * Debianization:
    - d/t/make-check-dev, refresh;
    - d/control:
      - Standards-Version, bump to 4.7.0 (no change).

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 21 Apr 2024 10:52:21 +0000

primesieve (12.1+ds-1) unstable; urgency=medium

  * New upstream minor version.
  * Debianization:
    - d/copyright:
      - Files-Excluded list, refresh.

 -- Jerome Benoit <calculus@rezozer.net>  Thu, 14 Mar 2024 09:33:37 +0000
