## primesieve 12.4+ds

=== debian/changelog ===
primesieve (12.4+ds-1) unstable; urgency=medium

  * New upstream minor version.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 01 Sep 2024 12:55:50 +0000
