## primesieve 12.6+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.4...3.27)
 project(primesieve CXX)
-set(PRIMESIEVE_VERSION "12.0")
-set(PRIMESIEVE_SOVERSION "12.0.0")
+set(PRIMESIEVE_VERSION "12.6")
+set(PRIMESIEVE_SOVERSION "12.6.0")
 
 # Build options ######################################################
 
@@ -44,6 +44,10 @@
 if(NOT isMultiConfig AND NOT CMAKE_BUILD_TYPE)
     set(CMAKE_BUILD_TYPE Release CACHE STRING
     "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
+endif()
+
+if(CMAKE_BUILD_TYPE STREQUAL "Debug")
+    list(APPEND PRIMESIEVE_COMPILE_DEFINITIONS "ENABLE_ASSERT")
 endif()
 
 # primesieve binary source files #####################################
@@ -78,6 +82,22 @@
             src/RiemannR.cpp
             src/SievingPrimes.cpp)
 
+# Check if compiler supports CPU multiarch ###########################
+
+if(WITH_MULTIARCH)
+    include("${PROJECT_SOURCE_DIR}/cmake/multiarch_x86_popcnt.cmake")
+    include("${PROJECT_SOURCE_DIR}/cmake/multiarch_avx512_bw.cmake")
+    include("${PROJECT_SOURCE_DIR}/cmake/multiarch_avx512_vbmi2.cmake")
+
+    if(NOT multiarch_avx512_bw)
+        include("${PROJECT_SOURCE_DIR}/cmake/multiarch_sve_arm.cmake")
+    endif()
+
+    if(multiarch_x86_popcnt OR multiarch_avx512_bw OR multiarch_avx512_vbmi2)
+        set(LIB_SRC ${LIB_SRC} src/x86/cpuid.cpp)
+    endif()
+endif()
+
 # Required includes ##################################################
 
 include(GNUInstallDirs)
@@ -103,13 +123,6 @@
     include("${PROJECT_SOURCE_DIR}/cmake/auto_vectorization.cmake")
 endif()
 
-# Check if compiler supports x64 multiarch ###########################
-
-if(WITH_MULTIARCH)
-    include("${PROJECT_SOURCE_DIR}/cmake/multiarch_popcnt_bmi.cmake")
-    include("${PROJECT_SOURCE_DIR}/cmake/multiarch_avx512.cmake")
-endif()
-
 # libprimesieve (shared library) #####################################
 
 find_package(Threads REQUIRED QUIET)
@@ -117,22 +130,13 @@
 if(BUILD_SHARED_LIBS)
     add_library(libprimesieve SHARED ${LIB_SRC})
     set_target_properties(libprimesieve PROPERTIES OUTPUT_NAME primesieve)
-    target_link_libraries(libprimesieve PRIVATE Threads::Threads ${LIBATOMIC})
+    target_link_libraries(libprimesieve PRIVATE Threads::Threads ${PRIMESIEVE_LINK_LIBRARIES})
     string(REPLACE "." ";" SOVERSION_LIST ${PRIMESIEVE_SOVERSION})
     list(GET SOVERSION_LIST 0 PRIMESIEVE_SOVERSION_MAJOR)
     set_target_properties(libprimesieve PROPERTIES SOVERSION ${PRIMESIEVE_SOVERSION_MAJOR})
     set_target_properties(libprimesieve PROPERTIES VERSION ${PRIMESIEVE_SOVERSION})
-    target_compile_options(libprimesieve PRIVATE ${FTREE_VECTORIZE_FLAG} ${FVECT_COST_MODEL_FLAG})
-
-    if(multiarch_popcnt_bmi)
-        target_compile_definitions(libprimesieve PRIVATE "MULTIARCH_POPCNT_BMI")
-    endif()
-    if(multiarch_avx512)
-        target_compile_definitions(libprimesieve PRIVATE "MULTIARCH_AVX512")
-    endif()
-    if(CMAKE_BUILD_TYPE STREQUAL "Debug")
-        target_compile_definitions(libprimesieve PRIVATE "ENABLE_ASSERT")
-    endif()
+    target_compile_options(libprimesieve PRIVATE ${PRIMESIEVE_COMPILE_OPTIONS})
+    target_compile_definitions(libprimesieve PRIVATE ${PRIMESIEVE_COMPILE_DEFINITIONS})
 
     if(WIN32_MSVC_COMPATIBLE)
         # On Windows the shared library will be named primesieve.dll
@@ -168,18 +172,9 @@
 if(BUILD_STATIC_LIBS)
     add_library(libprimesieve-static STATIC ${LIB_SRC})
     set_target_properties(libprimesieve-static PROPERTIES OUTPUT_NAME primesieve)
-    target_link_libraries(libprimesieve-static PRIVATE Threads::Threads ${LIBATOMIC})
-    target_compile_options(libprimesieve-static PRIVATE ${FTREE_VECTORIZE_FLAG} ${FVECT_COST_MODEL_FLAG})
-
-    if(multiarch_popcnt_bmi)
-        target_compile_definitions(libprimesieve-static PRIVATE "MULTIARCH_POPCNT_BMI")
-    endif()
-    if(multiarch_avx512)
-        target_compile_definitions(libprimesieve-static PRIVATE "MULTIARCH_AVX512")
-    endif()
-    if(CMAKE_BUILD_TYPE STREQUAL "Debug")
-        target_compile_definitions(libprimesieve-static PRIVATE "ENABLE_ASSERT")
-    endif()
+    target_link_libraries(libprimesieve-static PRIVATE Threads::Threads ${PRIMESIEVE_LINK_LIBRARIES})
+    target_compile_options(libprimesieve-static PRIVATE ${PRIMESIEVE_COMPILE_OPTIONS})
+    target_compile_definitions(libprimesieve-static PRIVATE ${PRIMESIEVE_COMPILE_DEFINITIONS})
 
     if(WITH_MSVC_CRT_STATIC)
         set_target_properties(libprimesieve-static PROPERTIES MSVC_RUNTIME_LIBRARY "MultiThreaded")
@@ -233,16 +228,10 @@
 
 if(BUILD_PRIMESIEVE)
     add_executable(primesieve ${BIN_SRC})
-    target_link_libraries(primesieve primesieve::primesieve)
+    target_link_libraries(primesieve primesieve::primesieve Threads::Threads)
+    target_compile_definitions(primesieve PRIVATE ${PRIMESIEVE_COMPILE_DEFINITIONS})
     target_compile_features(primesieve PRIVATE cxx_auto_type)
     install(TARGETS primesieve DESTINATION ${CMAKE_INSTALL_BINDIR})
-
-    if(multiarch_avx512)
-        target_compile_definitions(primesieve PRIVATE "MULTIARCH_AVX512")
-    endif()
-    if(CMAKE_BUILD_TYPE STREQUAL "Debug")
-        target_compile_definitions(primesieve PRIVATE "ENABLE_ASSERT")
-    endif()
 
     if(WITH_MSVC_CRT_STATIC)
         set_target_properties(primesieve PROPERTIES MSVC_RUNTIME_LIBRARY "MultiThreaded")
@@ -332,3 +321,14 @@
 # Add subdirectories #################################################
 
 if(BUILD_DOC)
+    add_subdirectory(doc)
+endif()
+
+if(BUILD_EXAMPLES)
+    add_subdirectory(examples)
+endif()
+
+if(BUILD_TESTS)
+    enable_testing()
+    add_subdirectory(test)
+endif()
