=== debian/changelog ===
primesieve (12.6+ds-1) unstable; urgency=medium

  * New upstream minor version.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 01 Dec 2024 16:32:10 +0000

primesieve (12.5+ds-1) unstable; urgency=medium

  * New upstream minor version.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 10 Nov 2024 02:04:41 +0000
