=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: primesieve
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Math Team <team+math@tracker.debian.org>
+Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders: Jerome Benoit <calculus@rezozer.net>
 Section: math
 Priority: optional
@@ -12,7 +11,7 @@
 Build-Depends-Indep:
  doxygen, doxygen-latex, graphviz,
  rdfind, symlinks
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Git: https://salsa.debian.org/math-team/primesieve.git
 Vcs-Browser: https://salsa.debian.org/math-team/primesieve
 Homepage: https://github.com/kimwalisch/primesieve
