## primesieve 12.7+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.4...3.27)
 project(primesieve CXX)
-set(PRIMESIEVE_VERSION "12.6")
-set(PRIMESIEVE_SOVERSION "12.6.0")
+set(PRIMESIEVE_VERSION "12.7")
+set(PRIMESIEVE_SOVERSION "12.7.0")
 
 # Build options ######################################################
 
@@ -89,12 +89,13 @@
     include("${PROJECT_SOURCE_DIR}/cmake/multiarch_avx512_bw.cmake")
     include("${PROJECT_SOURCE_DIR}/cmake/multiarch_avx512_vbmi2.cmake")
 
-    if(NOT multiarch_avx512_bw)
+    if(multiarch_x86_popcnt OR multiarch_avx512_bw OR multiarch_avx512_vbmi2)
+        set(LIB_SRC ${LIB_SRC} src/arch/x86/cpuid.cpp)
+    else()
         include("${PROJECT_SOURCE_DIR}/cmake/multiarch_sve_arm.cmake")
-    endif()
-
-    if(multiarch_x86_popcnt OR multiarch_avx512_bw OR multiarch_avx512_vbmi2)
-        set(LIB_SRC ${LIB_SRC} src/x86/cpuid.cpp)
+        if(multiarch_sve_arm)
+            set(LIB_SRC ${LIB_SRC} src/arch/arm/sve.cpp)
+        endif()
     endif()
 endif()
