=== debian/changelog ===
primesieve (12.7+ds-1) unstable; urgency=medium

  * New upstream minor version.
  * Debianization:
    - d/{copyright,adhoc/{c,cpp}/Makefile, copyright year-tuples, refrech;
    - d/control:
      - Standards-Version, bump to 4.7.2 (no change).

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 09 Mar 2025 14:57:31 +0000
