## primesieve 12.9+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.4...3.27)
 project(primesieve CXX)
-set(PRIMESIEVE_VERSION "12.7")
-set(PRIMESIEVE_SOVERSION "12.7.0")
+set(PRIMESIEVE_VERSION "12.9")
+set(PRIMESIEVE_SOVERSION "12.9.0")
 
 # Build options ######################################################
 
@@ -23,9 +23,8 @@
     option(BUILD_SHARED_LIBS "Build shared libprimesieve" OFF)
 endif()
 
-option(WITH_AUTO_VECTORIZATION "Enable compiler auto-vectorization" ON)
-option(WITH_MULTIARCH          "Enable runtime dispatching to fastest supported CPU instruction set" ON)
-option(WITH_MSVC_CRT_STATIC    "Link primesieve.lib with /MT instead of the default /MD" OFF)
+option(WITH_MULTIARCH       "Enable runtime dispatching to fastest supported CPU instruction set" ON)
+option(WITH_MSVC_CRT_STATIC "Link primesieve.lib with /MT instead of the default /MD" OFF)
 
 # libprimesieve sanity check #########################################
 
@@ -78,7 +77,7 @@
             src/ParallelSieve.cpp
             src/popcount.cpp
             src/PreSieve.cpp
-            src/PrimeSieve.cpp
+            src/PrimeSieveClass.cpp
             src/RiemannR.cpp
             src/SievingPrimes.cpp)
 
@@ -117,12 +116,6 @@
 # Check if libatomic is needed (old 32-bit systems) ##################
 
 include("${PROJECT_SOURCE_DIR}/cmake/libatomic.cmake")
-
-# Check if compiler supports auto vectorization ######################
-
-if(WITH_AUTO_VECTORIZATION)
-    include("${PROJECT_SOURCE_DIR}/cmake/auto_vectorization.cmake")
-endif()
 
 # libprimesieve (shared library) #####################################
 
@@ -136,7 +129,6 @@
     list(GET SOVERSION_LIST 0 PRIMESIEVE_SOVERSION_MAJOR)
     set_target_properties(libprimesieve PROPERTIES SOVERSION ${PRIMESIEVE_SOVERSION_MAJOR})
     set_target_properties(libprimesieve PROPERTIES VERSION ${PRIMESIEVE_SOVERSION})
-    target_compile_options(libprimesieve PRIVATE ${PRIMESIEVE_COMPILE_OPTIONS})
     target_compile_definitions(libprimesieve PRIVATE ${PRIMESIEVE_COMPILE_DEFINITIONS})
 
     if(WIN32_MSVC_COMPATIBLE)
@@ -157,9 +149,12 @@
         cxx_uniform_initialization
         cxx_lambdas)
 
-    target_include_directories(libprimesieve PUBLIC
+    target_include_directories(libprimesieve
+    PUBLIC
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
-        $<INSTALL_INTERFACE:include>)
+        $<INSTALL_INTERFACE:include>
+    PRIVATE
+        ${CMAKE_CURRENT_SOURCE_DIR}/src)
 
     install(TARGETS libprimesieve
             EXPORT primesieveShared
@@ -174,15 +169,10 @@
     add_library(libprimesieve-static STATIC ${LIB_SRC})
     set_target_properties(libprimesieve-static PROPERTIES OUTPUT_NAME primesieve)
     target_link_libraries(libprimesieve-static PRIVATE Threads::Threads ${PRIMESIEVE_LINK_LIBRARIES})
-    target_compile_options(libprimesieve-static PRIVATE ${PRIMESIEVE_COMPILE_OPTIONS})
     target_compile_definitions(libprimesieve-static PRIVATE ${PRIMESIEVE_COMPILE_DEFINITIONS})
 
     if(WITH_MSVC_CRT_STATIC)
         set_target_properties(libprimesieve-static PROPERTIES MSVC_RUNTIME_LIBRARY "MultiThreaded")
-    endif()
-
-    if(TARGET libprimesieve)
-        add_dependencies(libprimesieve-static libprimesieve)
     endif()
 
     target_compile_features(libprimesieve-static
@@ -193,9 +183,12 @@
         cxx_uniform_initialization
         cxx_lambdas)
 
-    target_include_directories(libprimesieve-static PUBLIC
+    target_include_directories(libprimesieve-static
+    PUBLIC
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
-        $<INSTALL_INTERFACE:include>)
+        $<INSTALL_INTERFACE:include>
+    PRIVATE
+        ${CMAKE_CURRENT_SOURCE_DIR}/src)
 
     install(TARGETS libprimesieve-static
             EXPORT primesieveStatic
@@ -214,12 +207,12 @@
 # that is in the PATH environment variable.
 
 if(WIN32 AND TARGET libprimesieve-static)
-    set(STATIC_LINKING ON)
+    set(STATICALLY_LINK_LIBPRIMESIEVE ON)
 elseif(NOT TARGET libprimesieve)
-    set(STATIC_LINKING ON)
-endif()
-
-if(STATIC_LINKING)
+    set(STATICALLY_LINK_LIBPRIMESIEVE ON)
+endif()
+
+if(STATICALLY_LINK_LIBPRIMESIEVE)
     add_library(primesieve::primesieve ALIAS libprimesieve-static)
 else()
     add_library(primesieve::primesieve ALIAS libprimesieve)
@@ -230,16 +223,13 @@
 if(BUILD_PRIMESIEVE)
     add_executable(primesieve ${BIN_SRC})
     target_link_libraries(primesieve primesieve::primesieve Threads::Threads)
+    target_include_directories(primesieve PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/src)
     target_compile_definitions(primesieve PRIVATE ${PRIMESIEVE_COMPILE_DEFINITIONS})
     target_compile_features(primesieve PRIVATE cxx_auto_type)
     install(TARGETS primesieve DESTINATION ${CMAKE_INSTALL_BINDIR})
 
     if(WITH_MSVC_CRT_STATIC)
         set_target_properties(primesieve PROPERTIES MSVC_RUNTIME_LIBRARY "MultiThreaded")
-    endif()
-
-    if(TARGET libprimesieve-static)
-        add_dependencies(primesieve libprimesieve-static)
     endif()
 endif()
