=== examples/CMakeLists.txt ===
add_subdirectory(c)
add_subdirectory(cpp)
