=== debian/changelog ===
primesieve (12.9+ds-2) unstable; urgency=medium

  * Upload to unstable.
  * Debianization:
    - d/patches/*:
      - d/p/upstream-workaround-doc-doxygen-LaTeX-tables.patch, introduce.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 17 Aug 2025 15:17:40 +0000

primesieve (12.9+ds-1) experimental; urgency=medium

  * New upstream minor version.
  * Debianization:
    - d/tests/*:
      - d/t/control, reorder tests;
      - d/t/make-check-dev, refresh.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 18 May 2025 13:24:37 +0000

primesieve (12.8+ds-1) experimental; urgency=medium

  * New upstream minor version.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 10 May 2025 17:24:03 +0000
