=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
 Build-Depends-Indep:
  doxygen, doxygen-latex, graphviz,
  rdfind, symlinks
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/math-team/primesieve.git
 Vcs-Browser: https://salsa.debian.org/math-team/primesieve
 Homepage: https://github.com/kimwalisch/primesieve
