=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,12 @@
 #!/usr/bin/make -f
+include /usr/share/dpkg/pkg-info.mk
+
+XDEB_VERSION_UPSTREAM_MAJOR=$(firstword $(subst ., ,$(DEB_VERSION_UPSTREAM)))
 
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
+
+## see preamble in `Changes in version 11.0' section of the ChangeLog
+XDEB_SONAME=$(XDEB_VERSION_UPSTREAM_MAJOR)
 
 ## inspired from mpfr material
 ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
@@ -46,7 +52,7 @@
 		-P $(BUILDDIR)/cmake_install.cmake
 
 override_dh_installdocs:
-	dh_installdocs -pprimesieve-bin    --link-doc=libprimesieve11
+	dh_installdocs -pprimesieve-bin    --link-doc=libprimesieve$(XDEB_SONAME)
 	dh_installdocs -plibprimesieve-dev --doc-main-package=libprimesieve-dev-common
 	dh_installdocs --remaining-packages
