=== test/CMakeLists.txt ===
--- 
+++ 
@@ -8,4 +8,14 @@
     target_include_directories(${binary_name} PRIVATE ${CMAKE_SOURCE_DIR}/src)
     target_compile_definitions(${binary_name} PRIVATE ${PRIMESIEVE_COMPILE_DEFINITIONS})
     add_test(NAME ${binary_name} COMMAND ${binary_name})
+
+    # Copy primesieve.dll to test directory.
+    # On Windows the DLLs must be in the same directory
+    # as the binaries that depend on them.
+    if (WIN32 AND NOT STATICALLY_LINK_LIBPRIMESIEVE)
+        add_custom_command(TARGET ${binary_name} POST_BUILD
+            COMMAND ${CMAKE_COMMAND} -E copy_if_different
+                $<TARGET_FILE:libprimesieve>
+                $<TARGET_FILE_DIR:${binary_name}>)
+    endif()
 endforeach()
