=== debian/changelog ===
primesieve (12.10+ds-1) unstable; urgency=medium

  * New upstream minor version.
  * Debianization:
    - d/patches/*:
      - d/p/upstream-workaround-doc-doxygen-LaTeX-tables.patch, integrated;
    - d/control:
      - Rules-Requires-Root field, now rely on default.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 16 Nov 2025 17:57:54 +0000
